unit USortFeld;

interface
uses classes,SysUtils,stdctrls,USortElement,UAnzeige,Dialogs;

type TSortFeld = class (TObject)
     private
       h_feld: array[0..1000] of TSortElement;
       h_anzahl : integer;
       xpos,ypos: integer;
       mem :TMemo;
     public
       constructor Create; virtual;
       destructor Destroy; override;
       procedure Add (neu: TSortElement); virtual;
       procedure Insert(Index:Integer;neu:TSortElement);virtual;
       procedure Delete(Index:Integer);virtual;
       procedure Exchange(Index1,Index2:Integer); virtual;
       function Get(Index:Integer):TSortElement;virtual;
       function GetCount:Integer;virtual;

       procedure zeigen(FA:TFAnzeige; vergleich:TSortElement;
                           von,bis,linkehand,rechteHand:Integer);
       procedure minsort ;virtual;
       procedure quicksort;
       procedure quick(von,bis:Integer);
       function indexOf (suchElement: TSortElement):Integer; virtual;
     end;

implementation

constructor TSortFeld.Create;
begin
   inherited create;
   h_anzahl  := 0;
end;

destructor TSortFeld.Destroy;
var i : Integer;
begin
   for i := 0 to h_anzahl-1 do
       h_feld[i].destroy;
   inherited destroy
end;

procedure TSortFeld.zeigen(FA:TFAnzeige; vergleich:TSortElement;
                           von,bis,linkehand,rechteHand:Integer);
  var I: integer;
      zeile:string;
  begin
    FA.LBAnzeige.Items.Clear;
    FA.LBAnzeige.Items.add('Quick von '+inttostr(von)+
                  ' bis '+inttostr(bis));
    FA.LBAnzeige.Items.add('Vergleich : '+vergleich.GetText);
    for i := 0 to h_anzahl-1 do
       begin
          zeile:=inttostr(i);
          if (1-i div 10)>0 then zeile := zeile+' ';
          if i=von then
             zeile  := zeile      + 'von ->'
          else if i=bis
             then zeile  := zeile + 'bis ->'
             else zeile  := zeile + '      ';
          if i=linkeHand
             then zeile  :=zeile + 'li ->'
             else zeile  :=zeile + '     ';
          if i=rechteHand
             then zeile := zeile + 're ->'
             else zeile := zeile + '     ';
          zeile := zeile + h_Feld[i].GetText;
          FA.LBAnzeige.Items.add(zeile);
       end;
       showmessagepos('ok',FA.Left,FA.top+FA.height);
  end; (*proc zeigen*)


procedure TSortFeld.Add (neu: TSortElement);
begin
   h_feld[h_anzahl] := TSortElement.create;
   h_feld[h_anzahl] := neu;
   h_anzahl  := h_anzahl+1;
end;

procedure TSortFeld.Insert(Index:Integer;neu:TSortElement);
var i :Integer;
begin
   if (Index <= h_anzahl) and (h_anzahl < maxint) then
     begin
       h_feld[h_anzahl+1]:=TSortElement.create;
       for i:= h_anzahl+1 downto index+1 do
           h_feld[i] := h_feld[i-1];
       h_feld[Index] := neu ;
       h_anzahl := h_anzahl+1
     end
end;

procedure TSortFeld.Delete(Index:Integer);
var i : Integer;
begin
   if index <= h_anzahl then
     begin
       for i := index to h_anzahl-1 do
          h_feld[i] := h_feld[i+1];
       h_feld[h_anzahl].destroy ;
       h_anzahl := h_anzahl-1 ;
     end
end;

procedure TSortFeld.Exchange(Index1,Index2:Integer);
var merk:TSortElement;
begin
   if (index1 <= h_anzahl) and (index2 <= h_anzahl) then
      begin
         merk := h_feld[index1];
         h_feld[index1]:=h_feld[index2];
         h_feld[index2]:= merk;
      end;
end;

procedure TSortFeld.minsort;
   var i,kleinste,schon_sortiert : integer;
begin
   for schon_sortiert := 0 to h_anzahl-1 do
      begin
//         showmessage('Schonsortiert: '+ IntToStr(schon_sortiert));
         kleinste := schon_sortiert+1;
//         showmessage('Kleinste: '+ IntToStr(kleinste));
         for i := schon_sortiert+2 to h_anzahl do begin
//            showmessage('i: '+ IntToStr(i));
            if h_feld[i].LessThan(h_feld[kleinste])
            then begin kleinste := i;
//                     showmessage('Kleinste: '+ IntToStr(kleinste));
                 end
         end;
//          showmessage('Austausch: '+ IntToStr(schon_sortiert+1)
//                       + '-' + IntToStr(kleinste));
          Exchange(schon_sortiert+1,kleinste);
      end
end;

procedure TSortFeld.quicksort;
begin
   xpos := 5;
   ypos := 5;
   quick(0,h_anzahl-1);
end;

procedure TSortFeld.quick(von,bis:Integer);
var linkeHand,rechteHand:Integer;
    vergleich,hilf :TSortElement;
    zeile:String;
    anzeige :TFAnzeige;
begin (* of proc quick *)
   showmessage('quick von '+inttostr(von)+'..bis '+inttostr(bis));
   if bis-von > 0 then begin
      anzeige := TFAnzeige.create(xpos,ypos);
(*      anzeige.left := xpos;
      anzeige.top  := ypos;
      anzeige.show; *)
      vergleich := h_Feld[(bis+von) div 2];
      linkeHand := von;
      rechteHand := bis;
      zeigen(anzeige,vergleich,von,bis,linkeHand,rechteHand);
      repeat
         while (rechteHand > von) and
               (linkeHand <= rechteHand) and
               h_feld[rechteHand].GreaterThan(vergleich) do begin
             dec(rechteHand);
             zeigen(anzeige,vergleich,von,bis,linkeHand,rechteHand);
         end;(*of while*)

         while (linkeHand < bis) and
               (linkeHand <= rechteHand) and
               h_feld[linkeHand].LessThan(vergleich) do begin
             inc(linkeHand);
             zeigen(anzeige,vergleich,von,bis,linkeHand,rechteHand);
         end; (* of while *)
         hilf := h_feld[linkeHand];
         h_feld[linkeHand] := h_feld[rechteHand];
         h_feld[rechteHand]:= hilf;
         zeigen(anzeige,vergleich,von,bis,linkeHand,rechteHand);
         if (linkeHand < bis) then inc(linkeHand);
         zeigen(anzeige,vergleich,von,bis,linkeHand,rechteHand);
         if (rechteHand > von)then dec(rechteHand);
         zeigen(anzeige,vergleich,von,bis,linkeHand,rechteHand);
      until linkehand > rechteHand;
      inc(xpos,200); quick(von,rechteHand);dec(xpos,200);
      zeigen(anzeige,vergleich,von,bis,linkeHand,rechteHand);
      inc(xpos,200);inc(ypos,20);quick(linkeHand,bis);
          dec(xpos,200);dec(ypos,20);
      zeigen(anzeige,vergleich,von,bis,linkeHand,rechteHand);
      showmessagepos('quick von '+inttostr(von)+'..bis '
               +inttostr(bis)+' wird beendet',
               anzeige.Left,anzeige.top+anzeige.height);
      anzeige.destroy;
   end (* of if *)
   else
      showmessage('quick von '+inttostr(von)+'..bis '
               +inttostr(bis)+' wird beendet');
end; (* of proc *)

function TSortFeld.indexOf (suchElement: TSortElement):Integer;
var i,index : Integer;
begin
   index := -1 ;
   i := 1;
   while (index = -1) and (i <= h_anzahl) do
     begin
        if h_feld[i].Equal(SuchElement) then
           index := i
        else
           i := i+1
     end;
   result := index   
end;

function TSortFeld.Get(Index:Integer):TSortElement;
begin
   result := h_feld[Index]
end;

function TSortFeld.GetCount:Integer;
begin
   result := h_anzahl
end;


end.
